<?php

//Fidsoft Related/Featured/Most Viewed Videos Module For Seyret V.1.0//
/**
* @ Version 1.0 
* @ Copyright (C) 2008 - 2009 Kirungi Fred Fideri at http://www.fidsoft.com
* @ Fidsoft Related/Featured/Most Viewed Videos Module for Seyret is free software
* @ Requires Seyret Video Component developed by Mustafa Dindar
* @ Uses Seyret All-In-One display template 
* @ Visit http://www.joomlaholic.com for more information about Seyret
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
**/	

// Prevent direct access

defined('_JEXEC') or die('Direct Access to this location is not allowed.');

class ModFidsoftRelated4Seyret 
{
    
    // Generates video list data
  
    function getData(&$params) 
    
    {
        
        //Retrieve parameters
        
        $seyretonly = $params->get ('seyretonly', 0);
        $currentpage = JRequest::getString('option');
        if ($seyretonly && ($currentpage != 'com_seyret')){
        return false;
        }
        
        $videolisttype = $params->get( 'videolisttype', 'related' );
        $videocount = $params->get( 'count', '5' );   
        $incategories = $params->get( 'incategories', '');
          if ($incategories!=""){
          $extraquerystring = ModFidsoftRelated4Seyret::getCats ($incategories); 
          } else {
          $extraquerystring = '';
          }       
        
        //Get video list
        
        if ($videolisttype == "related") {
        $data = ModFidsoftRelated4Seyret::getRelated ($extraquerystring, $params);
        } 
        elseif ($videolisttype == "weeklyview") {
        $data = ModFidsoftRelated4Seyret::getVideos ("weeklyview", $extraquerystring, ModFidsoftRelated4Seyret::getOrder("mostviewed"), $params);
        } else {
        $data = ModFidsoftRelated4Seyret::getVideos ("featured", $extraquerystring, ModFidsoftRelated4Seyret::getOrder("random"), $params);
        }
        return $data;
   
   } //End getData

     
    //Analyses categories and generates query string
    
    function getCats($incategories)
    
    {         

     $db = &JFactory::getDBO();
     
     //Process categories

     $extraquerystring="AND catid IN(";
	   $catids = explode(",", $incategories);
	       foreach ($catids as $catid){
		     $db -> setQuery("SELECT catid FROM #__seyret_categories WHERE id='$catid'");
		     $cat = $db ->loadResult();
		     $extraquerystring.="'$cat',";
	       }
	   $extraquerystring=substr($extraquerystring, 0, -1);
	   $extraquerystring.=")";
     return $extraquerystring; 

    } //End getCats


    //Retrieves related videos data
    
    function getRelated ($extraquerystring, $params)
    {
    
    //Get current video and preference settings
  
     $vid = JRequest::getInt('id');
     $planB = $params ->get ( 'planb', 'random');
     $relatedlogic = $params ->get ( 'relatedlogic', 'tagsonly');
     $keylen = $params ->get ( 'keylen', 0);
     $rubbish = $params ->get ( 'rubbish', '');
     $videocount = $params ->get ( 'count', 5);
     
     // Check if Seyret video is selected
     
     if (JRequest::getString('task') != 'videodirectlink'){
        if ($planB){
        return ModFidsoftRelated4Seyret::getVideos($planB, $extraquerystring, ModFidsoftRelated4Seyret::getOrder($planB), $params);
        } else {
        return false;
        }
     }
        
    //Process excluded words 
     
     $rubbish = str_replace (",", " ", $rubbish); 
     $rubbish = strtolower ($rubbish);    
     $rubbish = array_filter(explode(" ", $rubbish));
     array_walk($rubbish, "ModFidsoftRelated4Seyret::prepRubbish");
     $rubbish = array_merge ($rubbish, array('/\W/', '/\s/'));
   
     
    //Define query and get data for current video
    
     $query = "SELECT * FROM #__seyret_items WHERE published='1' AND id='$vid'";
     $db = &JFactory::getDBO();     
	   $db -> setQuery($query);
	   $videodata = $db -> loadObject();
	   $title = $videodata -> title;
	   $tags = $videodata -> videotags;
	   
	   //Process keywords for related videos
	      
        if ($relatedlogic == 'tagsonly') {
        $keywords = $tags;
        } elseif ($relatedlogic == 'titleonly'){
        $keywords = $title;
        } else {
        $keywords = $tags.' '.$title;
        }
     
      //For control purposes

        if (empty ($keywords)){
        $keywords = 'WRHTBOPW8_GOD_BLESS_FIDERI_RINYRJHJ';
        }
     
     $keywords = str_replace (",", " ", $keywords);
     $keywords = strtolower($keywords);
     $keywords = explode (" ", $keywords);
     $keywords = preg_replace ($rubbish, "", preg_replace (array("/\W/", "/\s/", "/^.{0,$keylen}$/"), "", $keywords));
     $keywords = array_filter(array_unique ($keywords));
     
      //Get related videos
      
        foreach ($keywords as $keyword) {
        $keyword = trim ($keyword);
        $query = "SELECT id FROM #__seyret_items WHERE published='1' AND (videotags LIKE '%$keyword%' OR title LIKE '%$keyword%' OR itemcomment LIKE '%$keyword%') $extraquerystring";
        $db -> setQuery ($query);
        $results [] = $db -> loadResultArray();
        }
        
        // Process related videos
      
        if (!empty ($results[0])){
        
        $results = ModFidsoftRelated4Seyret::arrayFlatten ($results); 
          if (is_array($results)){
          $results = array_unique ($results);
          $results = array_diff($results, array($vid));
          if (!empty ($results)) {
              foreach ($results as $results){
              $query = "SELECT * FROM #__seyret_items WHERE id = '$results'";
              $db -> setQuery($query);
              $data [] = $db -> loadObjectList();
              }
              $data = ModFidsoftRelated4Seyret::arrayFlatten ($data);
              $datacount = count($data);
              if ($datacount > $videocount){
              $data = array_splice($data, 0, $videocount);
              } 
            $data = array ('data'=>$data, 'label'=>"RELATED VIDEOS");
            } elseif ($planB) {
            $data = ModFidsoftRelated4Seyret::getVideos($planB, $extraquerystring, ModFidsoftRelated4Seyret::getOrder($planB), $params);
            } else {
            $data = false;
            }
          } 
        } elseif ($planB) {
          $data = ModFidsoftRelated4Seyret::getVideos($planB, $extraquerystring, ModFidsoftRelated4Seyret::getOrder($planB), $params);
        } else {
          $data = false;
        } 
     return $data;
     }//End GetRelated
	   

    //Retrieves featured, most viewed or fallback videos data
    
    function getVideos ($videolisttype, $extraquerystring, $orderby, $params)
    
    {
    
    $videocount = $params ->get ( 'count', 5);
    $daycount = $params ->get ('period', 7);
    
    // Define query
    $query = "SELECT * FROM #__seyret_items WHERE published='1'"; 
        if ($videolisttype == 'featured'){
        $query .= " AND featured = '1'";
        }
        if ($videolisttype == 'weeklyview'){
        $query .= " AND DATE_SUB(CURDATE(),INTERVAL $daycount DAY) <=addeddate";
        }
    $query .= " $extraquerystring $orderby";
    
    //Execute query and return results
    $db = &JFactory::getDBO();    
    $db ->setQuery($query, 0, $videocount);
    $videos = $db -> loadObjectList();
    if (empty($videos)){
    return false;
    }    
    $label = ModFidsoftRelated4Seyret::getLabel($videolisttype);
    $videos = array ('data'=>$videos, 'label'=>$label);
    return $videos;
    } //End getVideos
   
  
    // Defines list ordering logic
    
    function getOrder ($planB)
    {
    $orderby = " ORDER BY RAND() ";
        if ($planB == "latest"){
	      $orderby = " ORDER BY addeddate DESC ";
        } 
        if ($planB == "highestrated"){
	      $orderby = "  AND voteclick>0 ORDER BY votetotal/voteclick DESC, voteclick DESC ";
        } 
        if ($planB == "mostclicked"){
	      $orderby=" ORDER BY hit DESC ";
	      }
	      if ($planB == "mostdownloaded"){
	      $orderby = " ORDER BY downloadcount DESC ";
	      }
    return $orderby;
    } // End getOrder

    
    //Generates internal module title
    function getLabel ($planB)
    {
        if ($planB == "latest"){
	      $label = "LATEST VIDEOS";
        } 
        elseif ($planB == "highestrated"){
	      $label = "HIGHEST RATED VIDEOS";
        } 
        elseif ($planB == "mostclicked"){
	      $label = "MOST VIEWED VIDEOS";
	      }
	      elseif ($planB == "featured"){
	      $label = "FEATURED VIDEOS";
	      }
        elseif ($planB == "mostdownloaded"){
	      $label = "MOST DOWNLOADED VIDEOS";
	      } 
        elseif ($planB == "weeklyview"){
        $label = "MOST VIEWED THIS WEEK";
        } else{
        $label = "RANDOM VIDEOS";
        }
	  return $label;
	  }//End getLabel
    
    // Retrieves screenname
    
    function getName ($vaddedby, $nameformat)
    {
			  $query = "SELECT username, name FROM #__users WHERE id='$vaddedby'"; 	
        $db = &JFactory::getDBO();     
	      $db -> setQuery($query, 0, 1);	
			  $usname = $db ->loadObject();
			     if ($nameformat == 'username') {
           $name = $usname -> username;
           } else {
           $name = $usname -> name;
           }
        return $name;
		} //End getName

    //Retrieves Seyret Itemid
    
    function getSeyretid ()
    {
    $query = "SELECT id FROM #__menu WHERE link = 'index.php?option=com_seyret' AND published = '1'";
    $db = &JFactory::getDBO();     
    $db -> setQuery($query, 0, 1);
    $seyretid = $db -> loadResult();
    return $seyretid;
    } //End getSeyretid

   
   //Retrieves Category Names
   function showCats(){
   $videocats = array();
	 $query = "SELECT * FROM #__seyret_categories";
	 $db = &JFactory::getDBO();     
   $db -> setQuery($query);
   $myvidyocategory = $db -> loadObjectList();
	   foreach ($myvidyocategory as $myvidyocategory){
		  $catgname=$myvidyocategory->categoryname;
		  $cat_id=$myvidyocategory->catid;
		  $videocats[$cat_id] = $catgname;
	   }
   return $videocats;
   } //End showCats
   
    
    // Flattens a multidimensional array
    
    function arrayFlatten ($array)
    {
    while (($v = array_shift($array)) !== null) {
        if (is_array($v)) {
            $array = array_merge($v, $array);
        } else {
            $tmp[] = $v;
        }
    }
    return $tmp;
    } // End arrayFlatten
   
    //Prepares exclusion words
    function prepRubbish(&$value, $key)
    {
    $value = '/^'.$value.'$/';
    return $value;
    } //End prepRubbish  
}