<?php
/**
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
define( 'YOURBASEPATH', dirname(__FILE__) );
require( YOURBASEPATH.DS."menu_styleswitcher.php");
require( YOURBASEPATH.DS."menu_styles.php");
JHTML::_( 'behavior.mootools' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" >
<head>
	<jdoc:include type="head" />
	<?php
	$live_site        	= $mainframe->getCfg('live_site');
	$menu_name        	= $this->params->get("menuName", "mainmenu");
	$menu_type        	= $this->params->get("menuType", "moomenu");
	$menu_side        	= $this->params->get("menuSide", "left");
	$template_width 	= $this->params->get("templateWidth", "950");
	$leftcolumn_width	= $this->params->get("leftcolumnWidth", "160");
	$rightcolumn_width	= $this->params->get("rightcolumnWidth", "320");
	$leftinset_width	= $this->params->get("leftinsetWidth", "160");
	$rightinset_width	= $this->params->get("rightinsetWidth", "160");
		
	// moomenu options
	$moo_bgiframe     = ($this->params->get("moo_bgiframe'","0") == 0)?"false":"true";
	$moo_delay        = $this->params->get("moo_delay", "500");
	$moo_duration     = $this->params->get("moo_duration", "400");
	$moo_fps          = $this->params->get("moo_fps", "100");
	$moo_transition   = $this->params->get("moo_transition", "Expo.easeOut");	
	
	// counting modul
	$leftcolumn_width = ($this->countModules('left')>0) ? $leftcolumn_width : "0";
	$rightcolumn_width = ($this->countModules('right or tabber')>0) ? $rightcolumn_width : "0";
	$leftinset_width = ($this->countModules('inset2')>0 and !$editmode) ? $leftinset_width : "0";
	$rightinset_width = ($this->countModules('inset')>0 and !$editmode) ? $rightinset_width : "0";
	$template_width = 'margin: 0 auto; width: ' . $template_width . 'px;';
	$row1mod_count = ($this->countModules('user1')>0) + ($this->countModules('user2')>0) + ($this->countModules('user3')>0);
	$row1mod_width = $row1mod_count > 0 ? ' w' . floor(99 / $row1mod_count) : '';
	$extrasmod_count = ($this->countModules('user7')>0) + ($this->countModules('user8')>0) + ($this->countModules('user99')>0);
	$extrasmod_width = $extrasmod_count > 0 ? ' w' . floor(99 / $extrasmod_count) : '';
	$row3mod_count = ($this->countModules('user10')>0) + ($this->countModules('user11')>0) + ($this->countModules('user12')>0);
	$row3mod_width = $row3mod_count > 0 ? ' w' . floor(99 / $row3mod_count) : '';
	$template_path = $this->baseurl . "/templates/" . $this->template;
	require(YOURBASEPATH .DS."menu_styleloader.php");

	//counting frontpage component
	$frontpage_component    = $this->params->get("enableFrontpage", "show");

	// menu code
	$document	= &JFactory::getDocument();
	$renderer	= $document->loadRenderer( 'module' );
	$options	 = array( 'style' => "raw" );
	$module	 = JModuleHelper::getModule( 'mod_mainmenu' );
	$mainnav = false; $subnav = false;
	if($mtype == "splitmenu") : 
		$module->params	= "menutype=$menu_name\nstartLevel=0\nendLevel=1";
		$mainnav = $renderer->render( $module, $options );
		$module	 = JModuleHelper::getModule( 'mod_mainmenu' );
		$module->params	= "menutype=$menu_name\nstartLevel=1\nendLevel=9";
		$options	 = array( 'style' => "submenu");
		$subnav = $renderer->render( $module, $options );
	elseif($mtype == "moomenu" or $mtype == "suckerfish") : 								      	
		$module->params	= "menutype=$menu_name\nshowAllChildren=1\nclass_sfx=top";
		$mainnav = $renderer->render( $module, $options );
	endif;

	// make sure subnav is empty
	if (strlen($subnav) < 10) $subnav = false;

	?>
	
	<link href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/css/moomenu.css" rel="stylesheet" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/system/css/system.css" type="text/css" />
	<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/system/css/general.css" type="text/css" />
	<link href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/css/style.css" rel="stylesheet" type="text/css" />
	<style type="text/css">
	div#wrapper { <?php echo $template_width; ?>padding:0;}
	#leftside { width:<?php echo $leftcolumn_width; ?>px;padding:0;}
	#rightside { width:<?php echo $rightcolumn_width; ?>px;padding:0;}
	#centerside { margin-left:<?php echo $leftcolumn_width; ?>px;margin-right:<?php echo $rightcolumn_width; ?>px;padding:0;}
	#inset2 { width:<?php echo $leftinset_width; ?>px;padding:0;}
	#inset { width:<?php echo $rightinset_width; ?>px;padding:0;}
	#extras-wrap {margin-right:<?php echo $rightinset_width; ?>px;margin-left:<?php echo $leftinset_width; ?>px;padding:0;}
	</style>

	<!--[if lte IE 7]>
	<style type="text/css">
    #toptools {margin: 8px 0 1px 12px;} #register, #login {right:-10px;}

	</style>
	<![endif]-->
    
	<!--[if lte IE 6]>
	<link href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/css/ieonly.css" rel="stylesheet" type="text/css" />
	<style type="text/css">
	*{ behavior: url(<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/css/iepngfix.htc); } 
	.spacer.w99 .block {width: 99.5%;}
	.spacer.w49 .block {width: 48.25%;}
	.spacer.w33 .block {width: 30%;}
    .block {padding:3px;}
	.box-bl{padding-bottom:0; padding-left:0; overflow:hidden; margin-bottom:5px;}
    .extras-bl{padding-bottom: 25px; overflow:hidden; margin-bottom:5px;}
    .module-clean div div div, .module-blog div div div, .module-podcast div div div, .module-notitle div div div, #content .module div div div, #content .module_menu div div div{padding-bottom:10px; padding-left:5px; overflow:hidden; margin-bottom:5px;}
.rounded-left{margin-top:-24px;}
.rounded-right{margin-top:-14px; margin-bottom:6px;}

	</style>
	<![endif]-->
	
	<?php if($mtype=="moomenu") :?>
	<script type="text/javascript" src="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/js/mootools.bgiframe.js"></script>
	<script type="text/javascript" src="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/js/toptool.js"></script>
	<script type="text/javascript" src="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/js/menu_moomenu.js"></script>
	<script type="text/javascript" src="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template?>/js/sameheight.js"></script>
	<script type="text/javascript">
		window.addEvent('domready', function() {
			new Jommoomenu($E('ul.menutop'), {
				bgiframe: <?php echo $moo_bgiframe; ?>,
				delay: <?php echo $moo_delay; ?>,
				animate: {
					props: ['opacity', 'width', 'height'],
					opts: {
						duration:<?php echo $moo_duration; ?>,
						fps: <?php echo $moo_fps; ?>,
						transition: Fx.Transitions.<?php echo $moo_transition; ?>
				}
			}
		});
		});
	</script>
	<?php endif; ?>
	<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/css/<?php echo $this->params->get('fontFamily'); ?>.css" type="text/css" />
</head>
<body>
   <div id="wrapper">
   	  <div id="header">
   	  	<?php if ($this->params->get('logoType')=='image'){ ?>
			<div id="logo">
        		<a href="index.php"><img src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/images/logo.gif" alt="Your Company" title="Your Company" border="0" width="157" height="35" /></a>
        	</div>
	  	<?php } else{ ?>
    		<div id="logo">
				<h1 class="logo-module"><a href="index.php" title="<?php echo $this->params->get('siteName'); ?>"><span><?php echo $this->params->get('siteName'); ?></span></a></h1>
				<span class="site-slogan"><?php echo $this->params->get('sloganText'); ?></span>
    		</div>
	  	<?php } ?>
		<div id="header-mid">
        	<?php if ($this->countModules('search')) : ?>
        	<div id="search">
             		<jdoc:include type="modules" name="search" style="rounded" />
            <?php endif; ?>
            </div>
            <?php if ($this->countModules('user4')) : ?>
            <div id="breaking-nav">
                    <jdoc:include type="modules" name="user4" style="rounded" />
			</div>
			<?php endif; ?>
      	</div>
        <div id="header-right">
            <?php if ($this->countModules('user5')) : ?>
            <div id="topright-nav">
                    <jdoc:include type="modules" name="user5" style="rounded" />
			</div>
			<?php endif; ?>
      	</div>
      
      <div class="clr"></div>
      </div> 
      <!-- End Header -->
      
	  <!-- START NAVIGATION -->
      <div id="navigation_box">
      	<div id="horiz-menu">
        	<?php echo $mainnav; ?>
        	<div id="vert-menu">
            	<?php echo $subnav; ?>
            </div>
        </div>
		<?php if ($this->countModules('login')) : ?>
        <div id="toptools">
	    	<jdoc:include type="modules" name="login" />
		</div>
        <?php endif; ?> 
	  </div>        
      <div class="rounded-left"></div>
      <div class="rounded-right"></div>
	  <!-- NAVIGATION END -->
	
    <div class="clr"></div>
	
     <!-- START MAIN CONTENT -->
	 <div id="content">
     
		<!-- START ROW 1 -->
        <?php if ($this->countModules('user1') or $this->countModules('user2') or $this->countModules('user3')) : ?>
	  <div class="box-tr"><div class="box-tl"><div class="box-br"><div class="box-bl">
      		<div id="row1" class="spacer<?php echo $row1mod_width; ?>">
					<?php if ($this->countModules('user1')) : ?>
						<div class="block">
							<jdoc:include type="modules" name="user1" style="rounded" />
						</div>
					<?php endif; ?>
					<?php if ($this->countModules('user2')) : ?>
						<div class="block">
							 <jdoc:include type="modules" name="user2" style="rounded" />
						</div>
					<?php endif; ?>
                	<?php if ($this->countModules('user3')) : ?>
						<div class="block">
							 <jdoc:include type="modules" name="user3" style="rounded" />
						</div>
					<?php endif; ?>
             
					<div class="clr"></div>
                	</div>
	 	  </div></div></div></div>
        <?php endif; ?>
		<!-- END ROW 1 --> 

		<div class="clr" style="height:5px;"></div>
        
		<!-- START ROW 2 -->
       	<div id="row2">
        <!-- start left column -->
    	  <?php if ($this->countModules('left')) : ?>
			 <div id="leftside">
                <div class="box-tr"><div class="box-tl"><div class="box-br"><div class="box-bl">
					<jdoc:include type="modules" name="left" style="rounded" />
                </div></div></div></div>
             </div>
		  <?php endif; ?>
          <!-- end left column -->
		 
          <!-- start right column -->
    	  <?php if ($this->countModules('right or tabber')) : ?>
			 <div id="rightside">
                <div class="box-tr"><div class="box-tl"><div class="box-br"><div class="box-bl">
					<jdoc:include type="modules" name="right" style="rounded" /> <br/>
                    <jdoc:include type="modules" name="tabber" style="xhtml" />
                </div></div></div></div>
             </div>
		  <?php endif; ?>
          <!-- end right column -->                  
		  
          <!-- START CENTER COLUMN -->
          <div id="centerside">
           	 <div class="box-tr"><div class="box-tl"><div class="box-br"><div class="box-bl">
              <?php if ($this->countModules('inset') and !$editmode) : ?>
     		    <div id="inset"> <div class="leftpad">
					<jdoc:include type="modules" name="inset" style="rounded" />
			 	</div> </div>
            	<?php endif; ?>
                
                <?php if ($this->countModules('inset99') and !$editmode) : ?>
     		    <div id="inset2"> <div class="rightpad">
					<jdoc:include type="modules" name="inset99" style="rounded" />
			 	</div> </div>
            	<?php endif; ?>
                
                <?php if ($this->countModules('user6') or $this->countModules('user7 and user8')) : ?>
                <div id="extras-wrap">
             	<div class="extras-tr"><div class="extras-tl"><div class="extras-br"><div class="extras-bl">
                 	<h3 style="margin-bottom:15px;">inews Extras</h3>
                    <?php if ($this->countModules('user6')) : ?>
				   		<jdoc:include type="modules" name="user6" style="rounded" />
                 	<?php endif; ?>
                 	<?php if ($this->countModules('user7') and $this->countModules('user8')) : ?>       
      			 	<div id="extras" class="spacer<?php echo $extrasmod_width; ?>">
				 		<?php if ($this->countModules('user7')) : ?>
						<div class="block">
							<jdoc:include type="modules" name="user7" style="rounded" />
						</div>
						<?php endif; ?>
						<?php if ($this->countModules('user8')) : ?>
						<div class="block">
							<jdoc:include type="modules" name="user8" style="rounded" />
						</div>
						<?php endif; ?>
						<div class="clr"></div>
               		</div>
			    	<?php endif; ?>
				</div></div></div></div>
	 			</div>
               <?php endif; ?>
               <div class="clr"></div>
            
              	<?php if (!($frontpage_component == 'hide' and JRequest::getVar('view') == 'frontpage')): ?>
              	<div id="mainbody">
                	<jdoc:include type="component" />
              	</div>
              	<?php endif; ?>
              </div></div></div></div>
            </div>
            <!-- END CENTER COLUMN --> 
          </div>
    	  <!-- END ROW 2 -->
        
		<div class="clr" style="height:5px;"></div>
        
		<!-- START ROW 3 -->
        <?php if ($this->countModules('user10') or $this->countModules('user11') or $this->countModules('user12')) : ?>       
        <div class="box-tr"><div class="box-tl"><div class="box-br"><div class="box-bl">
      		<div id="row3" class="spacer<?php echo $row3mod_width; ?>">
					<?php if ($this->countModules('user10')) : ?>
						<div class="block">
							<jdoc:include type="modules" name="user10" style="rounded" />
						</div>
					<?php endif; ?>
					<?php if ($this->countModules('user11')) : ?>
						<div class="block">
							 <jdoc:include type="modules" name="user11" style="rounded" />
						</div>
					<?php endif; ?>
                	<?php if ($this->countModules('user12')) : ?>
						<div class="block">
							 <jdoc:include type="modules" name="user12" style="rounded" />
						</div>
					<?php endif; ?>
             
					<div class="clr"></div>
               </div>
		</div></div></div></div>
        <?php endif; ?>
		<!-- END ROW 3 -->
        
     </div>
	 <!-- MAIN CONTENT END -->
	 
     <!-- START FOOTER -->
     <div id="footer">
     	<?php if ($this->countModules('footer')) : ?>
	     	<div id="bottom-nav">
    	    	<jdoc:include type="modules" name="footer" style="xhtml" />
        	</div>
        <?php endif; ?>
        <div class="copyright" style="display:<?php echo $this->params->get('footerDisplay'); ?>;">
        
<?php if ($_SERVER["REQUEST_URI"] == '/') { ?>
 
                                                                                                                                                                                                                                                                                                          <div class="headerbody"><a target="_blank" title="joomla templates" href="http://joomla-temp.ru">templates joomla cms</a></div>
 
<?php } ?>            	        
		</div>
        <?php if ($this->countModules('user13')) : ?>
	     	<div id="bottom-right-nav">
    	    	<jdoc:include type="modules" name="user13" style="xhtml" />
        	</div>
        <?php endif; ?>
     </div>
     <!-- END FOOTER -->
   </div> 
</body>
</html>